{(   -*- nroff -*-

autogen template script=updater

)}
{(#

1999-06-26 original version, Jim Van Zandt <jrv@vanzandt.mv.com>
1999-06-28 modified to be template  Bruce Korb <autogen@linuxbox.com>
1999-07-04 nroff tweaks, Jim Van Zandt <jrv@vanzandt.mv.com>

)}/^.\\" @synopsis@$/,/^.\\" @@$/{
  if (!synopsis_updated) {
    print ".\\\" @synopsis@\n\
.B {(
  _IF prog_file_name _exist )}{(prog_file_name)}{(
  _ELSE)}{(prog_name _down)}{(
  _ENDIF)}{(

  _IF flag.value _exist )}{(
    _IF long_opts _exist )}{(

      # * * * * * * * * * * * * * * * * * * * * * * * * *
      #
      #  Mixture of short (flag) options and long options
      #
      )}\n\
.\\\" Mixture of short (flag) options and long options\n\
.RB [ -\\fIflag\\fP \" [\\fIvalue\\fP]]... [\" --\\fIopt-name\\fP [ = \"| ]\\fIvalue\\fP]]...\"{(

    _ELSE )}{(

      # * * * * * * * * * * * * * * * * * * * * * * * * *
      #
      #  Short (flag) options only
      #
      )}
.\\\" Short (flag) options only\n\
.RB [ -\\fIflag\\fP \" [\\fIvalue\\fP]]...\"{(
    _ENDIF )}{(

  _ELIF long_opts _exist )}{(

      # * * * * * * * * * * * * * * * * * * * * * * * * *
      #
      #  Long options only
      #
      )}\n\
.\\\" Long options only\n\
.RB [ --\\fIopt-name\\fP [ = \"| ] \\fIvalue\\fP]]...\"{(

  _ELIF argument _exist ! )}{(

      # * * * * * * * * * * * * * * * * * * * * * * * * *
      #
      #  All arguments are named options.
      #
      )}
.\\\" All arguments are named options.\n\
.RI [ opt-name \"[\\fB=\\fP\" value ]]...\n\
.PP\n\
All arguments are named options.{(

  _ELSE )}{(
    _ERROR "Named option programs cannot have arguments" )}{(
  _ENDIF )}{(

  _IF argument _exist )}
.br\n\
.in +8\n\
{(argument)}{(
  _ENDIF )}";
  print ".\\\" @@"
  }
  synopsis_updated=1;
  next;
}
/^.\\" @options@$/,/^.\\" @@$/{
  if (!options_updated) {
    print ".\\\" @options@";
{(

#  When there are no flag characters and long options are disallowed,
   the program options are all named options and they are handled
   without the marker character (hyphen). )}{(

_FOR flag

)}{(
  #  Skip the documentation options!
  #
  )}{(
  _IF documentation _exist ! )}print "\
.TP{(
      _IF value _exist )}{(
        _IF long_opts _exist )}{(

          # * * * * * * * * * * * * * * * * * * * *
          *
          *  The option has a flag value (character) AND
          *  the program uses long options
          *
          )}\n\
.BR -{(value)}{(
          _IF arg_name _exist ! )} \", \" --{(
          _ELSE )} \" \\fI{(arg_name)}\\fP, \" --{(
          _ENDIF )}{(name #_^ #-- _tr _down)}{(
          _IF arg_name _exist)}{(
            _IF flag_arg _len 0 = )} [ ={(
            _ELSE )} \" \" {(
            _ENDIF )}\\fI{(arg_name)}\\fP{(
            _IF flag_arg _len 0 = )} ]{(
            _ENDIF )}{(
          _ENDIF)}{(


        _ELSE   )}{(

          # * * * * * * * * * * * * * * * * * * * *
          *
          *  The option has a flag value (character) BUT
          *  the program does _NOT_ use long options
          *
          )}\n\
.BR -{(value)}{(
          _IF arg_name _exist)}{(
            _IF flag_arg _len 0 = )}[{(
            _ENDIF )} \"\\fI{(arg_name)}\\fP{(
            _IF flag_arg _len 0 = )}\"]\"{(
            _ENDIF )}{(
          _ENDIF)}{(
        _ENDIF  )}{(


      _ELSE  value does not exist -- named option only  )}{(

        _IF long_opts _exist ! )}{(

          # * * * * * * * * * * * * * * * * * * * *
          *
          *  The option does not have a flag value (character).
          *  The program does _NOT_ use long options either.
          *  Special magic:  All arguments are named options.
          *
          )}\n\
.BR {(name #_^ #-- _tr _down)}{(
        _IF arg_name _exist)} {(
          _IF flag_arg _len 0 = )} [ ={(
          _ELSE )} \"\" {(
          _ENDIF )}\\fI{(arg_name)}\\fP{(
          _IF flag_arg _len 0 = )}]{(
          _ENDIF )}{(
        _ENDIF)}{(


        _ELSE   )}{(

          # * * * * * * * * * * * * * * * * * * * *
          *
          *  The option does not have a flag value (character).
          *  The program, instead, only accepts long options.
          *
          )}\n\
.BR --{(name #_^ #-- _tr _down)}{(
          _IF arg_name _exist)} \"{(
            _IF flag_arg _len 0 = )}[{(
            _ENDIF )}\" \"=\\fI{(arg_name)}\\fP{(
            _IF flag_arg _len 0 = )}]{(
            _ENDIF )}\"{(
          _ENDIF)}{(
        _ENDIF  )}{(
      _ENDIF )}\n\
{(descrip)}{(
      _IF min           _exist
          max           _exist |
          enabled       _exist |
          no_preset     _exist |
          setable       _exist |
          equivalence   _exist |
          flags_must    _exist |
          flags_cant    _exist | )}.\n\
Special attributes apply to this option.\n\
See the invocation section in the info document.{(
      _ENDIF)}\n\
{(    _IF doc _exist)}.sp\n\
{(    _ENDIF)}{( 
# SED
   -e convert @code into \fB...\fP phrases
   -e convert @file into \fI...\fP phrases
   -e convert @var into \fB...\fP phrases
   -e Remove the '@' prefix from curly braces
   -e Indent example regions
   -e Delete example command
   -e Replade "end example" command with ".br"
   -e Replace "@*" command with ".br"
   -e Add "\n\" to the end of each line.

   NB:  backslashes are interpreted four times: by AutoGen, sed, awk 
	and nroff. Thus, for nroff to see one backslash, use eight (8)!!

   ))}{(
doc "sed						\
 -e's;@code{\\([^}]*\\)\};\\\\\\\\fB\\1\\\\\\\\fP;g'	\
 -e's;@file{\\([^}]*\\)\};\\\\\\\\fI\\1\\\\\\\\fP;g'	\
 -e's;@var{\\([^}]*\\)\};\\\\\\\\fB\\1\\\\\\\\fP;g'	\
 -e's/@\\([{}]\\)/\\1/'					\
 -e'/@ *example/,/@ *end *example/s/^/    /'		\
 -e'/^ *@ *example/d'					\
 -e's/^ *@ *end *example/.br/'				\
 -e's/^@\\*/.br/'					\
 -e's/$/\\\\n\\\\/' <<'_EOF_'\n%s\n_EOF_"
    _printf _shell )}{(

  _ENDIF documentation _exist ! )}.br";
{(

/flag


)}print "\
.TP\n\
.BR {(_IF flag.value _exist)}\\-? , \" --{(
      _ELIF long_opt _exist)}--{(_ENDIF)}help\n\
Display usage information and exit.\n\
.TP\n\
.BR {(_IF flag.value _exist)}-! , \" --{(
      _ELIF long_opt _exist)}--{(_ENDIF)}more-help\n\
Extended usage information passed thru pager.{(


_IF homerc _exist )}\n\
.TP\n\
.BR {(_IF flag.value _exist)}-> \" \\fIrcfile\\fP, --\" {(
      _ELIF long_opt _exist)}--{(_ENDIF)}save-opts \"[=\\fIrcfile\\fP] \n\
Save the option state to \\fIrcfile\\fP.\n\
.TP\n\
.BR {(_IF flag.value _exist)}-< \" \\fIrcfile\\fP, --\" {(
      _ELIF long_opt _exist)}--{(_ENDIF)}load-opts \"=\\fIrcfile\\fP\"\n\
Load options from \\fIrcfile\\fP.\n\
.TP\n\
.BR  --no-load-opts\n\
Disable loading options from an rc file.{(
_ENDIF)}{(


_IF version _exist )}\n\
.TP\n\
.BR {(_IF flag.value _exist)}\\-v \" [\" v | c | n \"], \" --{(
      _ELIF long_opt _exist)}--{(_ENDIF)}version [ =v | c | n ]\n\
Output version of program and exit.  The default mode is `v', a simple\n\
version.  The `c' mode will print copyright information and `n' will\n\
print the full copyright notice.{(
_ENDIF


)}";
  print ".\\\" @@"
  }
  options_updated=1;
  next;
}
{print}
